#include <asm.h>
#include <gtereg_s.h>
#include "offsets.asm"
#define SCRATCH 0x1f800000
      .text
      .align  2
      .extern _curdisplayp, 4

      .extern maxz, 4
      .extern minz, 4

      .extern rmaxz, 4
      .extern rminz, 4
      .extern zcor, 4
      .extern zfak, 4

        .globl DoObject
DoObject:
      sw      s0, SCRATCH+0
      sw      s1, SCRATCH+4
      sw      s2, SCRATCH+8
      sw      s3, SCRATCH+12
      sw      s4, SCRATCH+16
      sw      s5, SCRATCH+20
      sw      s6, SCRATCH+24
      sw      s7, SCRATCH+28
//      sw      s8, SCRATCH+32

        // als erstes mal light und color matrix setzen.
      lw    t0, object_s_scene(a0)         //  ; load light matrix.
      nop

      lw    t1, scene_s_l_dir+MATRIX_m+0(t0)
      lw    t2, scene_s_l_dir+MATRIX_m+4(t0)
      ctc2  t1, C2_L11L12
      ctc2  t2, C2_L13L21
      lw    t1, (scene_s_l_dir+MATRIX_m+8)(t0)
      lw    t2, (scene_s_l_dir+MATRIX_m+0xc)(t0)
      lw    t3, (scene_s_l_dir+MATRIX_m+0x10)(t0)
      ctc2  t1, C2_L22L23
      ctc2  t2, C2_L31L32
      ctc2  t3, C2_L33

      lw    t1, scene_s_l_color+MATRIX_m(t0)         //; load color matrix
      lw    t2, scene_s_l_color+MATRIX_m+0x4(t0)
      ctc2  t1, C2_LR1LR2
      ctc2  t2, C2_LR3LG1
      lw    t1, scene_s_l_color+MATRIX_m+0x8(t0)
      lw    t2, scene_s_l_color+MATRIX_m+0xc(t0)
      lw    t3, scene_s_l_color+MATRIX_m+0x10(t0)
      ctc2  t1, C2_LG2LG3
      ctc2  t2, C2_LB1LB2
      ctc2  t3, C2_LB3

      lw    t1, scene_s_l_color+MATRIX_t+0(t0)
      lw    t2, scene_s_l_color+MATRIX_t+4(t0)
      lw    t3, scene_s_l_color+MATRIX_t+8(t0)
      ctc2  t1, C2_RBK
      ctc2  t2, C2_GBK
      ctc2  t3, C2_BBK

        // dann die rotationsmatrix (und translationsmatrix) setzen
        // normalen werden jetzt mit skal. = 1 gemacht, sprich: garnicht.

      lw    t1, object_s_matrix+MATRIX_m+0(a0)
      lw    t2, object_s_matrix+MATRIX_m+4(a0)
      ctc2  t1, C2_R11R12
      ctc2  t2, C2_R13R21
      lw    t1, object_s_matrix+MATRIX_m+8(a0)
      lw    t2, object_s_matrix+MATRIX_m+0xc(a0)
      lw    t3, object_s_matrix+MATRIX_m+0x10(a0)
      ctc2  t1, C2_R22R23
      ctc2  t2, C2_R31R32
      ctc2  t3, C2_R33


      lw    t1, object_s_matrix+MATRIX_t+0(a0)
      lw    t2, object_s_matrix+MATRIX_t+4(a0)
      lw    t3, object_s_matrix+MATRIX_t+8(a0)
      ctc2  t1, C2_TRX
      ctc2  t2, C2_TRY
      ctc2  t3, C2_TRZ

        // und los gehts...

      lw      t0, object_s_faces(a0)          // t0: facecount

      lw      t1, object_s_face(a0)           // t1: face_base
      lw      t8, _curdisplayp                // t8: curdisplay

      lw      s6, display_t_wspace(t8)
      lw      t5, display_t_wspacepos(t8)
      add     s6, s6, t5                      // s6: wspacepos

      lui     t9, 0x0100                      // t9: 0x00FFFFFF
      subi    t9, t9, 1
      and     s6, s6, t9

      lw      s7, zfak

      lw      s0,  face_s_pos+0(t1)           // load first 3 points
      lw      s1,  face_s_pos+4(t1)
      lw      s2,  face_s_pos+8(t1)
      lw      s3, face_s_pos+12(t1)
      lw      s4, face_s_pos+16(t1)
      lw      s5, face_s_pos+20(t1)

      ctc2    s7, C2_ZSF4
      ctc2    s7, C2_ZSF3

      lw      s7, zcor

      lw      v0, rminz
      lw      v1, rmaxz

      beq     t0, zero, $DO_No_Faces
      nop
/*
   t0       facecount
   t1       face_base
   t2       face_type (eigentlich unntz, da nur tmapping oder nicht, aber evtl. wegen light)
   t3       is_tmapped?
   t4       unten addresse von OT-entry
   t5       immer mal wieder als temporary
   t6       "     "   "      "   "
   t7       "     "   "      "   "
   t8       curdisplay
   t9       0x00FFFFFF
   s0       next 3 points, #0, XY
   s1       next 3 points, #0, Z
   s2       next 3 points, #1, XY
   s3       next 3 points, #1, Z
   s4       next 3 points, #2, XY
   s5       next 3 points, #2, Z
   s6       wspacepos
   s7       zcor
   a0                * * * UNUSED * * *
   a1                * * * UNUSED * * *
   a2                * * * UNUSED * * *
   a3                * * * UNUSED * * *
   v0            (   * * * UNUSED * * *     )  minz
   v1            (   * * * UNUSED * * *     )  maxz
   k0                * * * UNUSED * * *
   k1                * * * UNUSED * * *
*/
$DO_face_loop:
                      // ...transfer them to the GTE..

      mtc2    s0, C2_VXY0
      mtc2    s1, C2_VZ0
      mtc2    s2, C2_VXY1
      mtc2    s3, C2_VZ1
      mtc2    s4, C2_VXY2
      mtc2    s5, C2_VZ2

      subi    t0, t0, 1
      cop2    0x0280030 // RTPT
        // 23cycles

      lw      s0, face_s_SIZE+face_s_pos+ 0(t1)    // load next 3 points
      lw      s1, face_s_SIZE+face_s_pos+ 4(t1)
      lw      s2, face_s_SIZE+face_s_pos+ 8(t1)
      lw      s3, face_s_SIZE+face_s_pos+12(t1)
      lw      s4, face_s_SIZE+face_s_pos+16(t1)
      lw      s5, face_s_SIZE+face_s_pos+20(t1)

      addi    t1, t1, face_s_SIZE   // increment face pointer

      lw      t2, face_s_type-face_s_SIZE(t1)

      cfc2    t5, C2_FLAG
      andi    t5, 4096
//      bne     t5, zero, $DO_Clipped
      andi    t3, t2, 8

      cop2    0x1400006   // NCLIP, "Normal clipping"
                    // 8cycles
      lw      t5, face_s_normal-face_s_SIZE+0(t1)  // load normal to vectorset #0    2words
      lw      t6, face_s_normal-face_s_SIZE+4(t1)

      mfc2    t7, C2_MAC0
      bne     t3, zero, $DO_No_Cull
      nop
      bgtz    t7, $DO_culled
$DO_No_Cull:

      mtc2    t5, C2_VXY0
      mtc2    t6, C2_VZ0

      li      t7, 0xFFFF    // (fuer unten)
      cop2    0x0486012 // RTV0
          // 8 cycles

      lwc2    C2_RGB, face_s_col-face_s_SIZE(t1)

          // -----------------------------------------------
          // Dieser CODE ist nur dazu da, eine absolute Idiotie der
          // GTE auszubuegeln, die nicht in der Lage ist,
          // a.) Die Vektoren dahin zu packen, wo sie auch gebraucht werden,
          // b.) diese Vektoren wenigstens IN DEM FORMAT abzulegen, in dem
          //     sie dann mal gebraucht werden
          // c.) irgendwelche(!) Befehle zum moven und am besten noch
          //     konvertieren innerhalb der GTE bereitzustellen.

      mfc2    t5, C2_IR2      // this code still sucks
      mfc2    t6, C2_IR1

      sll     t5, t5, 16    // das geht auch nicht einfacher, oder wie?!?
      and     t6, t6, t7
      or      t5, t5, t6

      mfc2    t7, C2_IR3
      mtc2    t5, C2_VXY0
      mfc2    t6, C2_SZ3
      mtc2    t7, C2_VZ0

      nop
      cop2    0x158002D   // AVSZ3
            // 5 cycles zeit
      subu    t7, t6, v1            // t7 = z - maxz
      bltz    t7, $NixMaxZ
      nop
      move    v1, t6
$NixMaxZ:

      subu    t7, t6, v0            // t7 = z - minz
      bgtz    t7, $NixMinZ
      nop
      move    v0, t6
$NixMinZ:

      mfc2    t5, C2_MAC0
      srl     t5, t5, 12

      cop2    0x108041B   // NCCS

          // 17 cycles zeit


      addu    t5, t5, s7          // zcor

      andi    t5, t5, 0xFFF       // (1<<OTSIZE)-1  ... nur damit da nix schiefgeht.
      xori    t5, t5, 0xFFF

      sll     t4, t5, 2         // sizeof(ot)

// ------------------ FLAT ------------------------
      andi    t3, t2, 1
      beq     t3, zero, $DO_no_flat
      nop

      add     t6, t4, t8
      lw      t7, display_t_ot(t6)    // ot-NOP (size: 0)
      sw      s6, display_t_ot(t6)    // address of current prim

      lui     t6, 0x400
      or      t6, t6, t7    // set len
      sw      t6, 0(s6)     // set len/address

      swc2    C2_RGB2, 4(s6)    // set effective color
      swc2    C2_SXY0, 8(s6)    // and screen-coordinates
      swc2    C2_SXY1, 12(s6)
      swc2    C2_SXY2, 16(s6)

      add     s6, s6, 5*4     // ...and increment the wspacepos

$DO_no_flat:

// ------------------ TMAP ------------------------
      andi    t3, t2, 2
      beq     t3, zero, $DO_no_texture
      nop

      add     t6, t4, t8
      lw      t7, display_t_ot(t6)    // ot-NOP (size: 0)
      sw      s6, display_t_ot(t6)    // address of current prim

      lui     t6, 0x700
      or      t6, t6, t7    // set len
      sw      t6, 0(s6)     // set len/address

      lw      t5, face_s_u0-face_s_SIZE(t1)
      lw      t6, face_s_u1-face_s_SIZE(t1)
      lw      t7, face_s_u2-face_s_SIZE(t1)

      sw      t5, 12(s6)  // u0, v0; u_short clut;
      sw      t6, 20(s6)  // u1, v1; u_short tpage;
      sw      t7, 28(s6)  // u2, v2; u_short pad1;
      swc2    C2_RGB2, 4(s6)    // set effective color
      swc2    C2_SXY0, 8(s6)    // and screen-coordinates
      swc2    C2_SXY1, 16(s6)
      swc2    C2_SXY2, 24(s6)

      add     s6, s6, 8*4     // ...and increment the wspacepos

$DO_no_texture:

// ------------------ WIRE ------------------------
      andi    t3, t2, 4
      beq     t3, zero, $DO_No_Wire
      nop

      add     t6, t4, t8
      addi    t6, t6, 4
      lw      t7, display_t_ot(t6)    // ot-NOP (size: 0)
      sw      s6, display_t_ot(t6)    // address of current prim

      lui     t6, 0x600
      or      t6, t6, t7    // set len
      sw      t6, 0(s6)     // set len/address

      lw      t6, face_s_col-face_s_SIZE+3*4(t1)
/*      mfc2    t5, C2_RGB2      // get effective color
      and     t5, t5, t9    // mask out code
      lui     t6, 0x4c00
      or      t6, t6, t5 */
      sw      t6, 4(s6)

      swc2    C2_SXY0, 8(s6)    // and screen-coordinates
      swc2    C2_SXY1, 12(s6)
      swc2    C2_SXY2, 16(s6)
      swc2    C2_SXY0, 20(s6)
      lui     t6, 0x5555
      ori     t6, t6, 0x5555
      sw      t6, 24(s6) // pad

      add     s6, s6, 7*4     // ...and increment the wspacepos

$DO_No_Wire:


$DO_culled:
$DO_Clipped:
      bgtz    t0, $DO_face_loop
      nop
      //      --------------------------------> FACELOOP ZUENDE

$DO_No_Faces:

/*      lw      t0, object_s_particles(a0)
      beq     t0, zero, $DO_No_Particles
      nop

      lw      t1, object_s_particle(a0)     // t1: particle_base

$DO_Particle_Loop:

      lwc2    C2_VXY0, particle_s_pos(t1)
      lwc2    C2_VZ0, particle_s_pos+4(t1)
      nop
      cop2 0x0180001   // rtps
          // 15 cycles


           ///     mann, hier nun das scheiss texture mapped flat

           //    quad in die ot einfgen, z wert irgendwie mit size

           // verrechnen, ach weiss der teufel.

      addi    t1, t1, particle_s_SIZE
      subi    t0, t0, 1
      bgtz    t0, $DO_Particle_Loop

$DO_No_Particles:
*/

      lw      t2, display_t_wspace(t8)      // update wspacepos

      sw      v0, rminz
      sw      v1, rmaxz

      and     t2, t2, t9
      sub     s6, s6, t2
      sw      s6, display_t_wspacepos(t8)

      lw      s0, SCRATCH+0
      lw      s1, SCRATCH+4
      lw      s2, SCRATCH+8
      lw      s3, SCRATCH+12
      lw      s4, SCRATCH+16
      lw      s5, SCRATCH+20
      lw      s6, SCRATCH+24
      lw      s7, SCRATCH+28
//      lw      s8, SCRATCH+32
      
      jr ra
      nop
        .globl TransZ
TransZ:
      lw      t0, zfak
      lw      t1, zcor
      ctc2    t0, C2_ZSF3
      mtc2    a0, C2_SZ0
      mtc2    a0, C2_SZ1
      mtc2    a0, C2_SZ2
      nop
      cop2    0x158002D   // AVSZ3

      mfc2    v0, C2_OTZ
      addu    v0, v0, t1          // zcor
      jr ra
      nop

.end
